// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

import './konsultationVorbereitung.less';

import { Checkbox, Form, Typography } from 'antd';
import React, { useEffect, useState } from 'react';
import { useTranslation } from 'react-i18next';
import { v4 as uuidv4 } from 'uuid';

import {
  Konsultation,
  KonsultationType,
  Regelungsalternative,
  Regelungsalternativen,
  RessortDTO,
} from '@plateg/rest-api';
import { CodeListenController, FormWrapper, InfoComponent, RepeatableFormComponent } from '@plateg/theme';
import { GlobalDI } from '@plateg/theme/src/shares/injector';

import { saveDraftContent } from '../../../../../shares/localStorage';
import { ROUTES } from '../../../../../shares/routes';
import { StandardEvorProps } from '../../component.react';
import { AdditionalRessortComponent } from './additional-konsultation/ressort/component.react';
import { AdditionalStellenComponent } from './additional-konsultation/stelle/component.react';
import { KonsultationTabelle } from './konsultation-tabelle/component.react';

interface KonsultationVorbereitungValues {
  regelungsalternativen: Regelungsalternativen;
  ressortList: Konsultation[];
  stellenList: Konsultation[];
}

export interface RegelungData {
  weiterverfolgen: boolean;
  id: string;
}

export function KonsultationVorbereitungComponent(props: StandardEvorProps): React.ReactElement {
  const { t } = useTranslation();
  const { Title } = Typography;
  const [form] = Form.useForm();
  const currentDraftId: string = props.currentDraft.id;
  const [selectedAlternativen, setSelectedAlternativen] = useState<{ alternativen: Regelungsalternative[] }>({
    alternativen: [],
  });
  const [ressortList, setRessortList] = useState<RessortDTO[]>([]);
  const [isDirty, setIsDirty] = useState(false);
  const alternativenList: Regelungsalternative[] =
    props.currentDraft.regelungsalternativen?.regelungsalternativeList || [];
  const codeListenController = GlobalDI.get<CodeListenController>('codeListenController');

  // First call current draft is not yet filled, so we give defaults
  const formInitialValue: KonsultationVorbereitungValues = {
    regelungsalternativen: props.currentDraft?.regelungsalternativen || { regelungsalternativeList: [] },
    ressortList: props.currentDraft?.konsultationen?.weitereKonsultationen.filter(
      (item) => item.type === KonsultationType.Ressort && !item.autoAdded,
    ) || [{ id: uuidv4(), name: '', text: '', type: KonsultationType.Ressort, autoAdded: false }],
    stellenList: props.currentDraft?.konsultationen?.weitereKonsultationen.filter(
      (item) => item.type === KonsultationType.Stelle,
    ) || [{ id: uuidv4(), name: '', text: '', type: KonsultationType.Stelle, autoAdded: false }],
  };

  useEffect(() => {
    const regelungsalternativen = props.currentDraft.regelungsalternativen?.regelungsalternativeList;
    if (regelungsalternativen !== undefined && regelungsalternativen.length > 0) {
      // Checkboxen auf true setzen, falls bisher noch nicht auf dieser Seite gewesen
      // Zudem Klick "simulieren", damit Tabelle angepasst wird
      regelungsalternativen.forEach((alternative) => {
        alternative.weiterverfolgen = alternative.weiterverfolgen === undefined ? true : alternative.weiterverfolgen;
        onCheckboxChange(alternative, alternative.weiterverfolgen);
      });
    }
  }, []);

  useEffect(() => {
    codeListenController.getCodeListen().subscribe({
      next: (data) => setRessortList(data.ressorts),
      error: (error) => console.log('Fehler beim Laden der Ressortliste', error),
    });
    props.setIsFormDirty?.(false);
  }, []);

  const saveDraft = () => {
    const values = form.getFieldsValue(true) as KonsultationVorbereitungValues;
    const autoGeneratedRessorts =
      props.currentDraft?.konsultationen?.weitereKonsultationen.filter((item) => item.autoAdded) || [];
    saveDraftContent({
      id: currentDraftId,
      regelungsalternativen: values.regelungsalternativen,
      konsultationen: {
        zusammenfassung: props.currentDraft?.konsultationen?.zusammenfassung,
        weitereKonsultationen: [...values.ressortList, ...values.stellenList, ...autoGeneratedRessorts],
      },
    });
  };

  const getRepeatableRessorts = () => {
    const ressorts =
      (form.getFieldsValue(true) as KonsultationVorbereitungValues).ressortList || formInitialValue.ressortList || [];
    ressorts.forEach((element, i) => {
      if (element.autoAdded) {
        ressorts.splice(i, 1);
      }
    });
    return ressorts;
  };

  const setRepeatableRessort = (ressortKonsultationen: Konsultation[]) => {
    const currentValues = form.getFieldsValue(true) as KonsultationVorbereitungValues;
    currentValues.ressortList = ressortKonsultationen;
    form.setFieldsValue(currentValues);
    setIsDirty(true);
  };

  const getRepeatableStelle = () => {
    return (
      (form.getFieldsValue(true) as KonsultationVorbereitungValues).stellenList || formInitialValue.stellenList || []
    );
  };

  const setRepeatableStelle = (stellenKonsultationen: Konsultation[]) => {
    const currentValues = form.getFieldsValue(true) as KonsultationVorbereitungValues;
    currentValues.stellenList = stellenKonsultationen;
    form.setFieldsValue(currentValues);
  };

  const onCheckboxChange = (alternative: Regelungsalternative, checked: boolean) => {
    if (checked) {
      setSelectedAlternativen((prev) => {
        prev.alternativen.push(alternative);
        return { ...prev };
      });
    } else {
      setSelectedAlternativen((prev) => {
        const itemIndex = prev.alternativen.findIndex((item) => item.id === alternative.id);
        if (itemIndex > -1) {
          prev.alternativen.splice(itemIndex, 1);
        }
        return { ...prev };
      });
    }
  };

  const title = (
    <div className="heading-holder">
      <Title level={1}>{t('konsultation.title')}</Title>
      <InfoComponent title={t('konsultation.konsultationTitleDrawer')}>
        <p className="ant-typography p-no-style">{t('konsultation.konsultationDrawerText1')}</p>
        <p className="ant-typography p-no-style">{t('konsultation.konsultationDrawerText2')}</p>
        <p className="ant-typography p-no-style">{t('konsultation.konsultationDrawerText3')}</p>
        <p className="ant-typography p-no-style">{t('konsultation.konsultationDrawerText4')}</p>
        <p className="ant-typography p-no-style">{t('konsultation.konsultationDrawerText5')}</p>
        <p className="ant-typography p-no-style">{t('konsultation.konsultationDrawerText6')}</p>
        <p className="ant-typography p-no-style">{t('konsultation.konsultationDrawerText7')}</p>
      </InfoComponent>
    </div>
  );

  return (
    <div className="konsultationVorbereitung-form">
      <FormWrapper
        projectName="eVoR"
        title={title}
        previousPage={`/evor/${currentDraftId}/${ROUTES.bewertung.bewertung}`}
        nextPage={`/evor/${currentDraftId}/${ROUTES.konsultation.konsultationErgebnisse}`}
        saveDraft={saveDraft}
        isDirty={() => isDirty}
        form={form}
        formInitialValue={formInitialValue}
        setFormInstance={props.setFormInstance}
        showMandatoryFieldInfo={true}
        handleFormChanges={() => {
          setIsDirty(true);
          props.setIsFormDirty?.(true);
        }}
      >
        <p className="ant-typography p-no-style">{t('konsultation.infoText1')}</p>
        <Title level={2}>{t('konsultation.subsubTitle1')}</Title>
        <Title level={3}>{t('konsultation.subsubTitle2')}</Title>
        <p className="ant-typography p-no-style">{t('konsultation.infoText2')}</p>
        <ul>
          {alternativenList.map((item: Regelungsalternative, index) => {
            const rang = item.rang ? 'Gesamtrang ' + item.rang.toString() : 'Gesamtrang n/a';
            return (
              <li key={item.id}>
                <Form.Item
                  name={['regelungsalternativen', 'regelungsalternativeList', index, 'weiterverfolgen']}
                  className="title-holder"
                  valuePropName="checked"
                >
                  <Checkbox
                    id={`evor-konsultationVorbereitungRegelungsalternativen-${item?.id}-chk`}
                    onChange={(event) => onCheckboxChange(item, event.target.checked)}
                  >
                    <span className="nonBreakingArea">
                      <span className="normalBreakingArea">{item.name}</span>&nbsp;
                      <div className="rang">{rang}</div>
                    </span>
                  </Checkbox>
                </Form.Item>
              </li>
            );
          })}
        </ul>
        <Title level={3}>{t('konsultation.subsubTitle3')}</Title>
        <Title level={4}>{t('konsultation.subsubTitle4')}</Title>
        <p className="ant-typography p-no-style">{t('konsultation.infoText3')}</p>
        <KonsultationTabelle
          currentDraft={props.currentDraft}
          selectedAlternativen={selectedAlternativen.alternativen}
        />
        <Title level={4}>{t('konsultation.subsubTitle5')}</Title>
        <p className="ant-typography p-no-style">{t('konsultation.infoText4')}</p>
        <Title level={4}>{t('konsultation.titleKosultRessort')}</Title>
        <RepeatableFormComponent
          getRepeatableItem={getRepeatableRessorts}
          setRepeatableItem={setRepeatableRessort}
          emptyItem={() => {
            return { id: uuidv4(), name: '', text: '', type: KonsultationType.Ressort, autoAdded: false };
          }}
          textAddItem={t('konsultation.addRessortBtn')}
          setDirtyFlag={() => setIsDirty(true)}
          repeatableComponent={(item: Konsultation, index: number, deleteItem: (index: number) => void) => (
            <AdditionalRessortComponent
              key={item.id}
              index={index}
              propertyName="ressortList"
              deleteButtonText={t('konsultation.deleteRessortBtn', { index: index + 1 })}
              deleteRessort={deleteItem}
              setDirtyFlag={() => setIsDirty(true)}
              autoFocus={getRepeatableRessorts().length > 1 && isDirty}
              ressorts={ressortList}
            />
          )}
        />
        <Title level={4}>{t('konsultation.subsubTitle6')}</Title>
        <p className="ant-typography p-no-style">{t('konsultation.infoText5')}</p>
        <Title level={4}>{t('konsultation.titleKosultStelle')}</Title>
        <RepeatableFormComponent
          getRepeatableItem={getRepeatableStelle}
          setRepeatableItem={setRepeatableStelle}
          emptyItem={() => {
            return { id: uuidv4(), name: '', text: '', type: KonsultationType.Stelle, autoAdded: false };
          }}
          textAddItem={t('konsultation.addStelleBtn')}
          setDirtyFlag={() => setIsDirty(true)}
          repeatableComponent={(item: Konsultation, index: number, deleteItem: (index: number) => void) => (
            <AdditionalStellenComponent
              key={item.id}
              index={index}
              propertyName="stellenList"
              deleteButtonText={t('konsultation.deleteStelleBtn', { index: index + 1 })}
              deleteStelle={deleteItem}
              setDirtyFlag={() => setIsDirty(true)}
              autoFocus={getRepeatableStelle().length > 1 && isDirty}
            />
          )}
        />
        <Title level={3}>{t('konsultation.subsubTitle7')}</Title>
        <p className="ant-typography p-no-style">{t('konsultation.infoText6')}</p>
        <ol>
          <li>{t('konsultation.infoText7')}</li>
          <li>{t('konsultation.infoText8')}</li>
          <li>{t('konsultation.infoText9')}</li>
          <li>{t('konsultation.infoText10')}</li>
        </ol>
        <p className="ant-typography p-no-style">{t('konsultation.infoText11')}</p>
      </FormWrapper>
    </div>
  );
}
